unit GasOut;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

const
 N=1000;
 nSteps=100000;
 nGraph=10000;
 cv:Real=0.00001;
 dt:Real=0.01;
 A:Real=0.0001;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  F,nF:Array[0..N] of Real;
  T:Array[1..nSteps] of Real;

implementation

{$R *.dfm}

function AverageV:Real;
var
 i:Integer;
 S:Real;
begin
 S:=0;
 for i:=0 to N do
  S:=S + i*F[i];
 AverageV:=S;
end;

function AverageV2:Real;
var
 i:Integer;
 S:Real;
begin
 S:=0;
 for i:=0 to N do
  S:=S + Sqr(i)*F[i];
 AverageV2:=S;
end;

procedure InitF;
var
 i:Integer;
 S:Real;
begin
 for i:=0 to N do
  F[i]:=exp(-cv*Sqr(i))*Sqr(i);
 S:=0;
 for i:=0 to N do
  S:=S + F[i];
 for i:=0 to N do
  F[i]:=F[i]/S;
end;

procedure DrawF;
var
 i:Integer;
 grX,grY:Integer;
 cX,cY:Real;
begin
 cX:=500/N;
 cY:=10000;
 Form1.Canvas.Pen.Color:=clGreen;
 Form1.Canvas.MoveTo(5,300);
 Form1.Canvas.LineTo(500,300);
 Form1.Canvas.MoveTo(10,305);
 Form1.Canvas.LineTo(10,5);
 for i:=0 to N do
 begin
  grX:=10 + Round(cX*i);
  grY:=300 - Round(cY*F[i]);
  Form1.Canvas.Pixels[grX,grY]:=clRed;
 end;

 cY:=AverageV;
 grX:=Round(cX*cY);
 Form1.Canvas.Pen.Color:=clBlue;
 Form1.Canvas.MoveTo(grX,300);
 Form1.Canvas.LineTo(grX,5);

 cY:=Sqrt(AverageV2);
 grX:=Round(cX*cY);
 Form1.Canvas.Pen.Color:=clYellow;
 Form1.Canvas.MoveTo(grX,300);
 Form1.Canvas.LineTo(grX,5);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 InitF;
 DrawF;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
 i,k:Integer;
 avV:Real;
begin
 for k:=1 to nSteps do
 begin
 
  T[k]:=AverageV2;
  avV:=AverageV;

  for i:=0 to N do
   nF[i]:=F[i] - A*F[i]*(i - avV)*dt;

  for i:=0 to N do
   F[i]:=nF[i];

  if (k mod nGraph)=0 then
   DrawF;

 end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
 k:Integer;
 F:File of Real;
begin
 AssignFile(F,'Results.dat');
 ReWrite(F);
 for k:=1 to nSteps do
  Write(F,T[k]);
 CloseFile(F); 
end;

end.
